﻿using System;
using Newtonsoft.Json;
using System.IO;
using System.Net;

namespace XServerJson
{
    class Program
    {
        // Make a request on xServer with JSON, using JSON.NET and dynamic/anonymous types.
        // This means we don't have any types defined for our requests and responses and do it like JavaScript.
        static void Main(string[] args)
        {
            // for input just use an anonymous type
            var gco = new
            {
                addr = new
                {
                    country = "L",
                    postCode = "",
                    city = "Schengen",
                    city2 = "",
                    street = "Rue de la Moselle 5",
                    houseNumber = ""
                }
            };

            // Create the request
            // When using using xServer-internet you need a token!
            var request = WebRequest.Create("https://xlocate-eu-n-test.cloud.ptvgroup.com/xlocate/rs/XLocate/findAddress");
            request.Credentials = new NetworkCredential("xtok", "<your xServer-internet token>");
            request.Method = "POST";
            request.ContentType = "application/json";

            // serialize object to the request stream 
            // should do some proper error-handly here
            using (var s = request.GetRequestStream())
            using (var writer = new StreamWriter(s))
            using (var jsonWriter = new JsonTextWriter(writer))
            {
                var ser = new JsonSerializer();
                ser.Serialize(jsonWriter, gco);
            }

            // now just parse it to a dynamic object           
            dynamic result;
            using (var response = request.GetResponse())
            using (var rs = response.GetResponseStream())
            using (var sr = new StreamReader(rs))
            {
                result = JsonConvert.DeserializeObject(sr.ReadToEnd());
            }

            // now work with the object like in JavaScript
            // You don't have intellisense, but can view the fields in the watch window of the debugger.
            foreach (var ra in result.resultList)
            {
                Console.WriteLine($"{ra.country} {ra.postCode} {ra.city} {ra.street} {ra.houseNumber}");
            }

            Console.ReadKey();
        }
    }
}
